Bugzilla will be upgraded to version 5.0 on a still to be determined date in the near future. The original upgrade date has been delayed.
Bug 1429804 - Review Request: parfait - Java libraries for Performance Co-Pilot (PCP)
Review Request: parfait - Java libraries for Performance Co-Pilot (PCP)
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Lukas Berk
Fedora Extras Quality Assurance
:
Depends On: 1429803 1434744 1434745 1434746 1434749 1434750
Blocks: FE-JAVASIG
  Show dependency treegraph
 
Reported: 2017-03-07 01:16 EST by Nathan Scott
Modified: 2017-09-06 18:23 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-09-06 18:23:59 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
lberk: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Nathan Scott 2017-03-07 01:16:32 EST
Spec URL:
https://bintray.com/pcp/f25/parfait/0.5.1#files
https://bintray.com/pcp/f25/download_file?file_path=parfait.spec

SRPM URL:
https://bintray.com/pcp/f25/parfait/0.5.1#files
https://bintray.com/pcp/f25/download_file?file_path=parfait-0.5.1-1.fc25.src.rpm

Description:
Parfait is a Java performance monitoring library, exposing and collecting metrics through a variety of outputs, including Performance Co-Pilot (pcp.io).
The package has been freshly released upstream after taking all patches sent post-RPM-packaging, and built under Fedora 25 with no rpmlint warnings/errors.

Fedora Account System Username: nathans, brolley, lberk
Comment 1 gil cattaneo 2017-03-10 23:16:38 EST
These ifile are not admitted in Fedora. Please, remove

BuildRequires: maven-shade-plugin

%pom_remove_plugin -r :maven-shade-plugin

pushd parfait-agent/target
install -m 644 parfait-agent-jar-with-dependencies.jar \
            %{buildroot}%{_javadir}/parfait/parfait.jar
popd
# special install of with-all-dependencies sample jar files
for example in acme sleep counter
do
    pushd examples/${example}/target
    install -m 644 example-${example}-jar-with-dependencies.jar \
                %{buildroot}%{_javadir}/parfait/${example}.jar
    popd
done

Please, remove also:
"Requires: java-headless >= 1.8" already listed as requirement by our java tools by default
"%dir %{_javadir}/parfait" already listed in 

"Group: ..." not MORE necessary

Please, change "%global disable_dropwizard 1" with "%bcond_with metrics". and
%if !%{disable_dropwizard}
BuildRequires: mvn(com.codahale.metrics:metrics-core)
%endif

with

%if %{with metrics}
BuildRequires: mvn(com.codahale.metrics:metrics-core)
%endif

and

%if %{disable_dropwizard}
%pom_disable_module parfait-dropwizard
%endif

with

%if %{without metrics}
%pom_disable_module parfait-dropwizard
%endif
Comment 2 Nathan Scott 2017-03-23 03:45:37 EDT
Hi gil,

(In reply to gil cattaneo from comment #1)
> These ifile are not admitted in Fedora. Please, remove
> 
> BuildRequires: maven-shade-plugin

Symbol shading is required for parfait-agent since it produces a javaagent jar which can be loaded at runtime into arbitrary Java applications.  The exact same approach is used by byteman, another javaagent which is already in Fedora, so I don't think there's an issue here.

> Please, remove also:
> "Requires: java-headless >= 1.8" already listed as requirement by our java
> tools by default
> "%dir %{_javadir}/parfait" already listed in 

Done.

> "Group: ..." not MORE necessary

Done.

> Please, change "%global disable_dropwizard 1" with "%bcond_with metrics". and
> %if %{with metrics}
> and
> %if %{without metrics}

Done.

I've uploaded revised packages here - https://bintray.com/pcp/f25/parfait

SPEC:  https://bintray.com/pcp/f25/download_file?file_path=parfait.spec
SRPM:  https://bintray.com/pcp/f25/download_file?file_path=parfait-0.5.1-3.fc25.src.rpm

cheers.
Comment 4 Lukas Berk 2017-09-05 15:20:40 EDT
The major holdup was the lack of licensing headers.  Patch submitted upstream to fix this which was incorporated into the latest release of parfait (0.5.3).  The review has updated the package version accordingly.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "LGPL (v2.1 or later)", "LGPL", "Unknown or
     generated", "*No copyright* Apache (v2.0)". 23 files have unknown
     license. Detailed output of licensecheck in /home/lberk/src/fedora-
     scm/review/review-parfait/licensecheck.txt
Reviewed this, the 23 files include manifest files, several images, and other small files.
All java files are properly licensed.
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/java
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 61440 bytes in 3 files.
Verified this is very limited readme files
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in parfait-
     javadoc , pcp-parfait-agent , parfait-examples
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: parfait-0.5.3-1.fc27.noarch.rpm
          parfait-javadoc-0.5.3-1.fc27.noarch.rpm
          pcp-parfait-agent-0.5.3-1.fc27.noarch.rpm
          parfait-examples-0.5.3-1.fc27.noarch.rpm
          parfait-0.5.3-1.fc27.src.rpm
5 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
parfait (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools
    mvn(cglib:cglib)
    mvn(com.google.guava:guava)
    mvn(commons-io:commons-io)
    mvn(commons-lang:commons-lang)
    mvn(javax.measure:unit-api)
    mvn(log4j:log4j:1.2.14)
    mvn(net.jcip:jcip-annotations)
    mvn(org.aspectj:aspectjweaver)
    mvn(org.slf4j:slf4j-api)
    mvn(org.slf4j:slf4j-simple)
    mvn(org.springframework:spring-beans)
    mvn(org.springframework:spring-context)
    mvn(org.springframework:spring-core)
    mvn(systems.uom:systems-quantity)
    mvn(systems.uom:systems-unicode-java8)
    mvn(tec.uom:uom-se)

parfait-examples (rpmlib, GLIBC filtered):

pcp-parfait-agent (rpmlib, GLIBC filtered):
    /bin/bash

parfait-javadoc (rpmlib, GLIBC filtered):
    javapackages-tools



Provides
--------
parfait:
    mvn(io.pcp.agentparfait:parfait-agent)
    mvn(io.pcp.agentparfait:parfait-agent:pom:)
    mvn(io.pcp.parfait:dxm)
    mvn(io.pcp.parfait:dxm:pom:)
    mvn(io.pcp.parfait:example-acme)
    mvn(io.pcp.parfait:example-acme:pom:)
    mvn(io.pcp.parfait:example-counter)
    mvn(io.pcp.parfait:example-counter:pom:)
    mvn(io.pcp.parfait:example-sleep)
    mvn(io.pcp.parfait:example-sleep:pom:)
    mvn(io.pcp.parfait:examples:pom:)
    mvn(io.pcp.parfait:parfait-core)
    mvn(io.pcp.parfait:parfait-core:pom:)
    mvn(io.pcp.parfait:parfait-io)
    mvn(io.pcp.parfait:parfait-io:pom:)
    mvn(io.pcp.parfait:parfait-jmx)
    mvn(io.pcp.parfait:parfait-jmx:pom:)
    mvn(io.pcp.parfait:parfait-pcp)
    mvn(io.pcp.parfait:parfait-pcp:pom:)
    mvn(io.pcp.parfait:parfait-spring)
    mvn(io.pcp.parfait:parfait-spring:pom:)
    mvn(io.pcp:parfait:pom:)
    parfait

parfait-examples:
    parfait-examples

pcp-parfait-agent:
    pcp-parfait-agent

parfait-javadoc:
    parfait-javadoc



Source checksums
----------------
https://github.com/performancecopilot/parfait/archive/0.5.3/parfait-0.5.3.tar.gz :
  CHECKSUM(SHA256) this package     : 231ab82d98373baf4c3a999410446b3ab5403a0ba21bd43bd72d872c33b97866
  CHECKSUM(SHA256) upstream package : 231ab82d98373baf4c3a999410446b3ab5403a0ba21bd43bd72d872c33b97866


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/bin/fedora-review -m fedora-rawhide-x86_64 -v -n parfait
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 5 Gwyn Ciesla 2017-09-06 10:20:58 EDT
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/parfait

Note You need to log in before you can comment on or make changes to this bug.